
// Chat scripts
function ScrollOff() {
  allowScroll = false;
}

function ScrollOn() {
  allowScroll = true;
  tempFreeze=false;
  pageScroll();
}

var tempFreeze=false;
var stopGifs=false;
var hidePostImages=false;

function scroll() {
    window.scrollTo(0, document.body.scrollHeight);
    isScrolling = true;
    ScrollOn();  
}

function scrolltobottom() {
    // Scroll once to bottom of page
    window.scrollTo(0, document.body.scrollHeight); 
    setTimeout('window.scrollBy(0,500)',50); // try to scroll some more
}

var allowScroll = true;
var isScrolling=false;
function pageScroll() {
    if (allowScroll && !tempFreeze) {
       isScrolling = true; 
       window.scrollBy(0,150); // horizontal and vertical scroll increments
       scrolldelay = setTimeout('pageScroll()',100); // scrolls every 100 milliseconds
    }
}

document.onscroll=function(e) {
    if (!isScrolling)
       app.scrolling();
    isScrolling = false;
};

var closedCopy = false;

var cKey = 67;

document.onkeydown=function(e){

    if (e.keyCode===67 && e.ctrlKey && closedCopy) {
        app.log("Prevented CTRL-C");
        e.preventDefault(); 
        return false;
    }
    var charCode = (e.which) ? e.which : e.keyCode;
    
    if (charCode === 33 || charCode === 34 || charCode === 36)  
        app.scrolling();
};

document.onkeyup=function(e) {
    var charCode = (e.which) ? e.which : e.keyCode;
    if (charCode === ctrlKey) ctrlDown = false;
};

function getSelectedhtml() {
    var sel = window.getSelection();
    var range = sel.getRangeAt(0);
    var frag = range.cloneContents();
    var div = document.createElement("div");
    div.appendChild(frag);
    return div.innerHTML;
}

function setcurline(line) {
  document.body.innerHTML=line;  
}

function gethtml() {
  return document.body.innerHTML;  
}

 
function setAnchor(nameAnchor) {
    window.scrollTo(0, $('#'+nameAnchor).offset().top);
}

function goToAnchor(nameAnchor) {
    window.scrollTo(0, $('#'+nameAnchor).offset().top);
    
//    $('html, body').animate({
//        scrollTop: $("#"+nameAnchor).offset().top
//    }, 2000);    
}    

function deleteLine() {
   var content=document.getElementById('content');
   var first = content.firstChild;
   content.removeChild(first);
 }
 
 var maxLines = 1500;  // before deleting lines
 
 function addLine(line) {
   var content=document.getElementById('content');
   var newline=document.createElement('div');
   newline.innerHTML=line;
   content.appendChild(newline);
   var childCount = content.childNodes.length;
   if(childCount>maxLines) {deleteLine();}
   if (allowScroll) scroll();
   if (hidePostImages) hideImages(); 
      else limitImageSize();
   //else app.log(">>> NOT Scrolling: tempFreeze="+tempFreeze+"  allowScroll="+allowScroll);
   redirectLinks();
   repaint();
   if (stopGifs) setTimeout('stopGifAnimations()',6000);
}

function appendLine(line) {
   var content=document.getElementById('content');
   var newline=document.createElement('div');
   newline.innerHTML=line;
   content.appendChild(newline);
   limitImageSize();
}

function repaint() {
    var content=document.getElementById('content');
    content.style.display = 'inline-block';
    content.offsetHeight;
    content.style.display = 'block';
}

function setBackgroundColor(color) {
  document.bgColor = color;
}

function loadCSS(css) {
     $('head > link').filter(':first').attr('href', css); 
}

function replacePost(user, line, html) {
    $(".post."+user+".l"+line).html(html);
}

function replaceAllPosts(user, html) {
    $(".post."+user).html(html);
}

function replaceLastPosts(user, html) {
    $(".post."+user).slice(-2).html(html);
}

function ftHidePost(user, line) {
    
    if ($(".post."+user+".l"+line+" #hide").length) {
        app.log("Hiding again line "+line+ " from "+user);
        $(".post."+user+".l"+line+" #hide").hide();
        $(".post."+user+".l"+line+" #link").show(); 
    } else
      app.hidePost(user, line);
}

function ftcaptureImage(url, name, origin) {
     app.log("got here");
     app.captureImage(url, name, origin);
    }
    
  

function hidePost(user, line, html) {
    setTimeout(function () {
        var orig = getPost(user, line);
        var hidden  = html+"<div class='hidden' id='hide' style='display:none'>"+orig+"</div>";
        replacePost(user, line, hidden);
        redirectLinks();
      }, 50);
}

function hideFromView(user, line, html) {
    setTimeout(function () {
        var orig = getPost(user, line);
        var hidden  = html+"<div id='hide' style='display:none'>"+orig+"</div>";
        replacePost(user, line, hidden);
        redirectLinks();
      }, 50);
}

function getPost(user, line) {
    return $(".post."+user+".l"+line).html();
}

function ftShow(user, line) {
    app.log("Showing hidden line "+line+ " from "+user);
    $(".post."+user+".l"+line+" #hide").show();
    $(".post."+user+".l"+line+" #link").hide(); 
}


function voiceplay(id) {
    $(".post.l"+id+" table").removeClass("play").removeClass("queue").addClass("pause");	
	$(".post.l"+id+" .bar").removeClass("hide");
}

function voicestop(id) {
   $(".post.l"+id+" table").removeClass("pause").addClass("play");	
   $(".post.l"+id+" .bar").addClass("hide");
   $(".post.l"+id+" table").addClass("played");
   setTimeout(function () {     
	  $(".post.l"+id+" .bar").css({ width: '0%' });	
   }, 1200);
}

function voicequeue(id) {
   $(".post.l"+id+" table").addClass("queue");	
}

function voiceduration(id, duration) {
   $(".post.l"+id+" #d").html(duration);	
}

function voiceprogress(id, percentComplete) {
   $(".post.l"+id+" .bar").css({ width: percentComplete * 100 + '%' });	
}

function voicequeueremove(id) {
   $(".post.l"+id+" table").removeClass("queue");	
}


function redirectLinks() {
    // intercept all links
    var handler = function(){
           if(this.href.indexOf("javascript:void(0)")===0 ) return true;
           if(this.href.indexOf("javascript:ft")===0 )  return true;
           if(this.href.indexOf("javascript:app.")===0 )  return true;
           
           app.click(this.href);
           //app.log("redirectLinks: redirected: "+this.href);
           return false;
       };

   for (var ls = document.links, numLinks = ls.length, i=0; i<numLinks; i++){
       if(ls[i].href.indexOf("javascript:void(7)")!==0)
            ls[i].onclick= handler;
   }
   
    var formsCollection = document.getElementsByTagName("form");
    for(var i=0;i<formsCollection.length;i++)
    {
       //formsCollection[i].action = "http://www.filetopia.org";
       formsCollection[i].onsubmit = function( e ) {
            app.log("formsCollection[i].onsubmit called"); 
            e.stopPropagation();
            e.preventDefault(); 
        };
    }    
}

function hideImages() {
    $( ".freezeframe" ).hide(); 
    $( ".freezeframe_done" ).hide(); 
    $("img").not(".ftimg").hide();
    $("canvas").hide();
    hidePostImages = true;
    //$( ".freezeframe" ).prop("disabled", true);
    //$( ".freezeframe_done" ).prop("disabled", true);
}

function limitImageSize() {
    $("img").addClass("limit-size");
}

function showImages() {
    
    $( ".freezeframe" ).show(); 
    $( ".freezeframe_done" ).show(); 
    $("img").not(".ftimg").show();
    $("canvas").show();
    hidePostImages = false;
    limitImageSize();
    //$( ".freezeframe" ).css( "display", "block" ); 
    //$( ".freezeframe_done" ).css( "display", "block" );
    //$( ".freezeframe" ).prop("disabled", false);
    //$( ".freezeframe_done" ).prop("disabled", false); 

}

function stopGifAnimations() {
    if (hidePostImages) return;
    var images = [];
    var class_name = "freezeframe";
    images = $('img[class*="' + class_name + '"]')
			.not('[class*="' + class_name + '_done"]');
    if (images.size()>0) {            
        app.log("stopGifAnimations running on "+images.size());             
        $(images).each(function(index) {
           $(this).removeClass(class_name).addClass(class_name + "_done");
		   freeze_gif(this);
       });
    }
}

   
function freeze_gif(i) {
    if (hidePostImages) return;
    var blank = document.createElement('canvas');
	var c = document.createElement('canvas');
    var w = c.width = i.width;
    var h = c.height = i.height;
	try {
		c.getContext('2d').drawImage(i, 0, 0, w, h);     
	} catch(err) { app.log("error="+err.message); }
    var d = document.createElement('div');
    d.appendChild(c);    
    d.setAttribute('style', "display: inline; text-align:center;");     
    i.parentNode.replaceChild(d, i); 

    var animating = false;

    $(d).mouseenter(function() {	
        if (animating) return;
        if (hidePostImages) return;
        animating = true;
        d.replaceChild(i, c);   
        setTimeout(function () {
            if (hidePostImages) return;    
            if (animating) {
                c.getContext('2d').clearRect ( 0 , 0 , w, h);
                c.getContext('2d').drawImage(i, 0, 0, w, h); 
                i.parentNode.replaceChild(c, i); 
            }
            animating = false;
        }, 5000);
    });
    
//    $(d).mouseleave(function() {
//        c.getContext('2d').clearRect ( 0 , 0 , w, h);
//        c.getContext('2d').drawImage(i, 0, 0, w, h);  
//        i.parentNode.replaceChild(c, i); 
//        animating = false;
//    });
}

