
document.onpaste=function(e) {
    if (closepaste || app.checkclipboard(document.body.innerHTML)) {
        app.log("DOCUMENT unathorized paste attempt detected: preventing");
        e.stopPropagation();
        e.preventDefault(); 
    }  
    else setTimeout('checkLinks()',100); 
    
    app.log("Paste detected");
};


window.onload = function() {
  app.setup();
};

document.onkeydown=function(e){
    if( app.checkspecial(document.body.innerHTML, e.keyCode)) {
        e.preventDefault(); 
    }  
};

document.onkeyup=function(e) {
    var code = e.which || e.keyCode;
    if (code === 27) {
        app.log('ESC key pressed');
        gethtml();
    }
};

var closepaste = false;

document.onkeypress=function(evnt){
    
    var charCode =  evnt.keyCode;  //(evnt.which) ? evnt.which : evnt.keyCode;
    if (charCode === 13 && !evnt.shiftKey) {
        app.sendtext();
        evnt.preventDefault();  // this was a tricky issue to catch :)
    } 
    
    else {
        if( app.checktext(document.body.innerHTML, String.fromCharCode(charCode))) {
            evnt.preventDefault(); 
            //evnt.stopPropagation();
               
        }  
    }    
};


// WebKit contentEditable focus bug workaround:  
var editableFix = $('<input style="width:1px;height:1px;border:none;margin:0;padding:0;" tabIndex="-1">').appendTo('html');
$(function(){
    $('[contenteditable]').blur(function () {
//       setTimeout('document.getElementById("editor").focus()',200);
//       editableFix[0].setSelectionRange(0, 0);
//       editableFix.blur();
    });
  });
function focusFix() {
//    editableFix.focus();
}

function cursorAtEnd() {
    // set caret at end
    var sel = window.getSelection();
    var range = sel.getRangeAt(0);
    range = document.createRange();
    range.selectNodeContents(document.body.lastChild);
    range.collapse(false);
    sel.removeAllRanges();
    sel.addRange(range);
}

function focusTest() {
   document.getElementById("editor").blur();
   editableFix.focus();
   document.getElementById("editor").focus();
}
  

function checkLinks() {
    // intercept all links
    var handler = function(){
           if(this.href.indexOf("javascript:")===0) return true;
           //alert("not allowed");
           app.log("checkLinks: intercepted: "+this.href);
           return false;
       };

   for (var ls = document.links, numLinks = ls.length, i=0; i<numLinks; i++){
       ls[i].onclick= handler;
   }
   
   var formsCollection = document.getElementsByTagName("form");
    for(var i=0;i<formsCollection.length;i++)
    {
       //formsCollection[i].action = "http://www.filetopia.org";
       formsCollection[i].onsubmit = function( e ) {
            app.log("formsCollection[i].onsubmit called"); 
            e.stopPropagation();
            e.preventDefault(); 
        };
    }    
}


function chatReplace(str1, str2) {
    
    var len = str1.length;   
    var newElem = document.createTextNode(str2);
    
    
    var sel = window.getSelection();
    //app.log("selection :"+sel);    
    var range = sel.getRangeAt(0);
    //app.log("Range startnode:"+range.startNode);
    range.collapse(false);
    //app.log("Range endoffset: "+range.endOffset);
    range.setStart(range.startContainer, range.endOffset-len+1);
    range.deleteContents();
    range.insertNode(newElem);

    range = range.cloneRange();
    range.selectNodeContents(newElem);
    range.collapse(false);
    sel.removeAllRanges();
    sel.addRange(range);
}

function insertHTML(str) {
    var newElem = document.createElement ("span"); 
    newElem.innerHTML = str;
    var sel = window.getSelection();
    var range = sel.getRangeAt(0);
    range.insertNode(newElem);  
    range.selectNodeContents(newElem);
 
    range.collapse(false);
    sel.removeAllRanges();
    sel.addRange(range);
}

function chatImageReplace(str1, img) {
    
    var len = str1.length;   
    var sel = window.getSelection();
    var range = sel.getRangeAt(0);
    //app.log("Range startnode:"+range.startNode);
    range.collapse(false);
    range.setStart(range.startContainer, range.endOffset-len+1);
    range.deleteContents();
    addImage(img);
}

function getCaretCharacterOffsetWithin(element) {
    var caretOffset = 0;
    
    var range = window.getSelection().getRangeAt(0);
    var preCaretRange = range.cloneRange();
    preCaretRange.selectNodeContents(element);
    preCaretRange.setEnd(range.endContainer, range.endOffset);
    caretOffset = preCaretRange.toString().length;
    return caretOffset;
}     
  
function getcurline() {
  return document.body.innerHTML;  
}

function sethtml(line) {
   document.body.innerHTML=line;  
   setTimeout('checkLinks()',100); 
}

function setcurline(line) {
  document.body.innerHTML=line; 
  if (line!=='') {
    var last = document.body.lastChild;
    if (last)
      placeCaretAtEnd(last);
  }
  setTimeout(checkLinks,100); 
}

function gethtml() {
  var html = document.body.innerHTML;
  // Clear editor
  document.body.innerHTML = "";
//  while(document.body.childNodes.length >0)
//     document.body.removeChild(document.body.firstChild);
  // prepare the color/font for next line
  SetInitialFont();
  closepaste = false;
  return html;
}  

function getSelectedhtml() {
    var sel = window.getSelection();
    var range = sel.getRangeAt(0);
    var frag = range.cloneContents();
    var div = document.createElement("div");
    div.appendChild(frag);
    return div.innerHTML;
}

function isSelected() {
    var sel = window.getSelection();
    return sel.toString()!=='';
}


function SetInitialFont() {
    var newElem = document.createElement ("div"); //span");
    newElem.innerHTML = "\u200b"; // Zero width Space
    
    if (savedSize)
        newElem.style.fontSize = savedSize+"px";
    if (savedcolor)
        newElem.style.color = savedcolor;
    if (savedBold)
       newElem.style.fontWeight = savedBold;
    if (savedStyle)
        newElem.style.fontStyle = savedStyle;
    
    
    document.body.appendChild(newElem);   
    var rangeObj = document.createRange();
    rangeObj.selectNode(newElem);
    var sel = window.getSelection();
    sel.addRange(rangeObj);
    // Place caret at end
    var range = document.createRange();
    range.selectNodeContents(newElem);
    range.collapse(false);
    sel.removeAllRanges();
    sel.addRange(range);
}

function setBackgroundColor(color) {
  document.bgColor = color;
}

function loadCSS(css) {
     $('head > link').filter(':first').attr('href', css); 
}

var savedSize;

function SetFontSize(size) {
   
   var sel = window.getSelection();
   if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        if (range.toString().length>0) {
            //
            applyFontSizeToSelection(size);
            range.collapse(false);
            // set caret at end
            range = document.createRange();
            range.selectNodeContents(document.body.lastChild);
            range.collapse(false);
            sel.removeAllRanges();
            sel.addRange(range);
        } else {
            savedSize = size;    
            var newElem = document.createElement ("span");
            newElem.innerHTML = "\u200b"; // Zero width Space
            newElem.style.fontSize = size+"px";
            range.insertNode(newElem);
            range.selectNodeContents(newElem);
            range.collapse(false);
            sel.removeAllRanges();
            sel.addRange(range);
        }
    }
}

var savedBold;

function SetFontBold(weight) {
   
   
   var sel = window.getSelection();
   if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        if (range.toString().length>0) {
                applyClassToSelection(weight==800?'fontbold':'fontthin');
                range.collapse(false);
                // set caret at end
                range = document.createRange();
                range.selectNodeContents(document.body.lastChild);
                range.collapse(false);
                sel.removeAllRanges();
            sel.addRange(range);
        } else {
                savedBold = weight;
                var newElem = document.createElement ("span");
                newElem.innerHTML = "\u200b"; // Zero width Space
                newElem.style.fontWeight = weight;
                range.insertNode(newElem);
                range.collapse(false);
                sel.removeAllRanges();
                sel.addRange(range);
        }
    }
}

var savedStyle;

function SetFontStyle(style) {
   
   var sel = window.getSelection();
   if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        if (range.toString().length>0) {
            applyClassToSelection(style==='normal'?'fontnormal':'fontitalic');
            range.collapse(false);
            // set caret at end
            range = document.createRange();
            range.selectNodeContents(document.body.lastChild);
            range.collapse(false);
            sel.removeAllRanges();
            sel.addRange(range);
        } else {
            savedStyle = style;
            var newElem = document.createElement ("span");
            newElem.innerHTML = "\u200b"; // Zero width Space
            newElem.style.fontStyle = style;
            range.insertNode(newElem);
            range.collapse(false);
            sel.removeAllRanges();
            sel.addRange(range);
        }
    }
}


var savedcolor;

function SetFontColor(color) {
   
   var sel = window.getSelection();
   if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        if (range.toString().length>0) {
                applyFontColorToSelection(color);
                range.collapse(false);
                // set caret at end
                range = document.createRange();
                range.selectNodeContents(document.body.lastChild);
                range.collapse(false);
                sel.removeAllRanges();
                sel.addRange(range);
        } else {
                savedcolor = color;
                var newElem = document.createElement ("span");
                newElem.innerHTML = "\u200b"; // Zero width Space
                newElem.style.color = color;
                range.insertNode(newElem);
                range.collapse(false);
                sel.removeAllRanges();
                sel.addRange(range);
        }
    }
}

function setupEditor() {
    app.log("setting up!");
    document.getElementById('editor').focus();
    gethtml();
}

function addImage(img) {
    if (closepaste) return;
    var newimg=document.createElement('a');
    newimg.innerHTML=img;
    insertNodeAtCaret(newimg);
    return;
}

function addImageLink(img, link, title) {
    if (closepaste) return;
    var newimg=document.createElement("a");
    newimg.setAttribute("href", link);
    newimg.setAttribute("title", title);
    newimg.innerHTML=img;
    insertNodeAtCaret(newimg);
    return;
}


function insertNodeAtCaret(node) {
    var sel = window.getSelection();
    if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        range.collapse(false);
        range.insertNode(node);

        range = range.cloneRange();
        range.selectNodeContents(node);
        range.collapse(false);
        sel.removeAllRanges();
        sel.addRange(range);
    }
}

// Color Rainbow code
function colorRainbow(text) {
    
    var rainbowtext = '';
    var hue=Math.random()*360; 
    var step=0;

    // hue is 360 degrees
    if (text.length > 0)
    step = 360 / (text.length);

    // iterate the whole 360 degrees
    for (var i = 0; i < text.length; i++)
    {
        rainbowtext = rainbowtext + '<span style="color:' + color_from_hue(hue) + '">' + text.charAt(i) + '</span>';
        hue += step;
        if (hue>=360) hue = 0;
    }
    
    return rainbowtext;
}    
    
function SetRainbow() {   
   var sel = window.getSelection();
   if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        if (range.toString().length>0) {
                
                var frag = range.cloneContents();
                var div = document.createElement("div");
                div.appendChild(frag);
                var colored = colorRainbow(div.innerText);
                //
                var item=document.createElement('span');
                item.innerHTML = colored;
                //
                range.deleteContents();
                range.insertNode(item);
                //
                range = range.cloneRange();
                range.selectNodeContents(item);
                range.collapse(false);
                sel.removeAllRanges();
                sel.addRange(range);
        } else {
               // Toggle rainbow mode when writting 
        }
    }
}

function color_from_hue(hue)
{
  var h = hue/60;
  var c = 255;
  var x = (1 - Math.abs(h%2 - 1))*255;
  var color;
 
  var i = Math.floor(h);
  if (i === 0) color = rgb_to_hex(c, x, 0);
  else if (i === 1) color = rgb_to_hex(x, c, 0);
  else if (i === 2) color = rgb_to_hex(0, c, x);
  else if (i === 3) color = rgb_to_hex(0, x, c);
  else if (i === 4) color = rgb_to_hex(x, 0, c);
  else color = rgb_to_hex(c, 0, x);
 
  return color;
}
 
function rgb_to_hex(red, green, blue)
{
  var h = ((red << 16) | (green << 8) | (blue)).toString(16);
  // add the beginning zeros
  while (h.length < 6) h = '0' + h;
  return '#' + h;
}


// Safe sorrounding 
//var nextId = 0;

var rangeIntersectsNode = (typeof window.Range !== "undefined"
        && Range.prototype.intersectsNode) ?

    function(range, node) {
        return range.intersectsNode(node);
    } :

    function(range, node) {
        var nodeRange = node.ownerDocument.createRange();
        try {
            nodeRange.selectNode(node);
        } catch (e) {
            nodeRange.selectNodeContents(node);
        }

        return range.compareBoundaryPoints(Range.END_TO_START, nodeRange) === -1 &&
            range.compareBoundaryPoints(Range.START_TO_END, nodeRange) === 1;
    };

function applyClassToSelection(cssClass) {
    //var uniqueCssClass = "selection_" + (++nextId);
    var sel = window.getSelection();
    if (sel.rangeCount < 1) {
        return;
    }
    var range = sel.getRangeAt(0);
    var startNode = range.startContainer, endNode = range.endContainer;

    // Split the start and end container text nodes, if necessary
    if (endNode.nodeType === 3) {
        endNode.splitText(range.endOffset);
        range.setEnd(endNode, endNode.length);
    }

    if (startNode.nodeType === 3) {
        startNode = startNode.splitText(range.startOffset);
        range.setStart(startNode, 0);
    }

    // Create an array of all the text nodes in the selection
    // using a TreeWalker
    var containerElement = range.commonAncestorContainer;
    if (containerElement.nodeType !== 1) {
        containerElement = containerElement.parentNode;
    }

    var treeWalker = document.createTreeWalker(
        containerElement,
        NodeFilter.SHOW_TEXT,
        // Note that Range.intersectsNode is non-standard but
        // implemented in WebKit
        function(node) {
            return rangeIntersectsNode(range, node) ?
                NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_REJECT;
        },
        false
    );

    var selectedTextNodes = [];
    while (treeWalker.nextNode()) {
        selectedTextNodes.push(treeWalker.currentNode);
    }

    var textNode, span;

    // Place each text node within range inside a <span>
    // element with the desired class
    for (var i = 0, len = selectedTextNodes.length; i < len; ++i) {
        textNode = selectedTextNodes[i];
        span = document.createElement("span");
        span.className = cssClass; // + " " + uniqueCssClass;
        textNode.parentNode.insertBefore(span, textNode);
        span.appendChild(textNode);
    }

    return; // uniqueCssClass;
}

function applyFontSizeToSelection(size) {
    //var uniqueCssClass = "selection_" + (++nextId);
    var sel = window.getSelection();
    if (sel.rangeCount < 1) {
        return;
    }
    var range = sel.getRangeAt(0);
    var startNode = range.startContainer, endNode = range.endContainer;

    // Split the start and end container text nodes, if necessary
    if (endNode.nodeType === 3) {
        endNode.splitText(range.endOffset);
        range.setEnd(endNode, endNode.length);
    }

    if (startNode.nodeType === 3) {
        startNode = startNode.splitText(range.startOffset);
        range.setStart(startNode, 0);
    }

    // Create an array of all the text nodes in the selection
    // using a TreeWalker
    var containerElement = range.commonAncestorContainer;
    if (containerElement.nodeType !== 1) {
        containerElement = containerElement.parentNode;
    }

    var treeWalker = document.createTreeWalker(
        containerElement,
        NodeFilter.SHOW_TEXT,
        // Note that Range.intersectsNode is non-standard but
        // implemented in WebKit
        function(node) {
            return rangeIntersectsNode(range, node) ?
                NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_REJECT;
        },
        false
    );

    var selectedTextNodes = [];
    while (treeWalker.nextNode()) {
        selectedTextNodes.push(treeWalker.currentNode);
    }

    var textNode, span;

    // Place each text node within range inside a <span>
    // element with the desired class
    for (var i = 0, len = selectedTextNodes.length; i < len; ++i) {
        textNode = selectedTextNodes[i];
        span = document.createElement("span");
        span.style.fontSize = size+"px";
        textNode.parentNode.insertBefore(span, textNode);
        span.appendChild(textNode);
    }

    return;  
}

function applyFontColorToSelection(color) {
    //var uniqueCssClass = "selection_" + (++nextId);
    var sel = window.getSelection();
    if (sel.rangeCount < 1) {
        return;
    }
    var range = sel.getRangeAt(0);
    var startNode = range.startContainer, endNode = range.endContainer;

    // Split the start and end container text nodes, if necessary
    if (endNode.nodeType === 3) {
        endNode.splitText(range.endOffset);
        range.setEnd(endNode, endNode.length);
    }

    if (startNode.nodeType === 3) {
        startNode = startNode.splitText(range.startOffset);
        range.setStart(startNode, 0);
    }

    // Create an array of all the text nodes in the selection
    // using a TreeWalker
    var containerElement = range.commonAncestorContainer;
    if (containerElement.nodeType !== 1) {
        containerElement = containerElement.parentNode;
    }

    var treeWalker = document.createTreeWalker(
        containerElement,
        NodeFilter.SHOW_TEXT,
        // Note that Range.intersectsNode is non-standard but
        // implemented in WebKit
        function(node) {
            return rangeIntersectsNode(range, node) ?
                NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_REJECT;
        },
        false
    );

    var selectedTextNodes = [];
    while (treeWalker.nextNode()) {
        selectedTextNodes.push(treeWalker.currentNode);
    }

    var textNode, span;

    // Place each text node within range inside a <span>
    // element with the desired class
    for (var i = 0, len = selectedTextNodes.length; i < len; ++i) {
        textNode = selectedTextNodes[i];
        span = document.createElement("span");
        span.style.color = color;
        textNode.parentNode.insertBefore(span, textNode);
        span.appendChild(textNode);
    }
    
    range.collapse(false);
    sel.removeAllRanges();
    sel.addRange(range);

    return;  
}

function placeCaretAtEnd(el) {
    el.focus();
    if (typeof window.getSelection !== "undefined"
            && typeof document.createRange !== "undefined") {
        var range = document.createRange();
        range.selectNodeContents(el);
        range.collapse(false);
        var sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(range);
    } else if (typeof document.body.createTextRange !== "undefined") {
        var textRange = document.body.createTextRange();
        textRange.moveToElementText(el);
        textRange.collapse(false);
        textRange.select();
    }
}

//function removeSpansWithClass(cssClass) {
//    var spans = document.body.getElementsByClassName(cssClass),
//        span, parentNode;
//
//    // Convert spans to an array to prevent live updating of
//    // the list as we remove the spans
//    spans = Array.prototype.slice.call(spans, 0);
//
//    for (var i = 0, len = spans.length; i < len; ++i) {
//        span = spans[i];
//        parentNode = span.parentNode;
//        parentNode.insertBefore(span.firstChild, span);
//        parentNode.removeChild(span);
//
//        // Glue any adjacent text nodes back together
//        parentNode.normalize();
//    }
//}

// Clipboard paste handling
function handlepaste (elem, e) {
    e = document.getElementebyId('editor');
    var savedcontent = elem.innerHTML;
    app.log("handlePaste, saved content = "+elem.innerHTML);
    
    if (e && e.clipboardData && e.clipboardData.getData) {// Webkit - get data from clipboard, put into editdiv, cleanup, then cancel event
        if (/text\/html/.test(e.clipboardData.types)) {
            elem.innerHTML = e.clipboardData.getData('text/html');
        }
        else if (/text\/plain/.test(e.clipboardData.types)) {
            elem.innerHTML = e.clipboardData.getData('text/plain');
        }
        else {
            elem.innerHTML = "";
        }
        waitforpastedata(elem, savedcontent);
        if (e.preventDefault) {
                e.stopPropagation();
                e.preventDefault();
        }
        app.log("handlePaste, clipboard = "+elem.innerHTML);
        return false;
    }
    else {// Everything else - empty editdiv and allow browser to paste content into it, then cleanup
        elem.innerHTML = "";
        waitforpastedata(elem, savedcontent);
        return true;
    }
}

function waitforpastedata (elem, savedcontent) {
    if (elem.childNodes && elem.childNodes.length > 0) {
        app.log("waitforpastedata, object childnodes = "+elem.childNodes.length);
        processpaste(elem, savedcontent);
        
    }
    else {
        that = {
            e: elem,
            s: savedcontent
        };
        that.callself = function () {
            waitforpastedata(that.e, that.s);
        };
        setTimeout(that.callself,20);
    }
}

function processpaste (elem, savedcontent) {
    pasteddata = elem.innerHTML;
    //^^Alternatively loop through dom (elem.childNodes or elem.getElementsByTagName) here

    elem.innerHTML = savedcontent;

    // Do whatever with gathered data;
    app.log("PASTED DATA = "+pasteddata);
}
